package com.tzld.piaoquan.recommend.feature.model;

import lombok.Data;

@Data
public class AdActionFeature {
    private double adView=0d;
    private double adClick=0d;
    private double adConversion=0d;

    private double ctr=0d;
    private double cvr=0d;

    private double ceilLog(Double key) {
        return Math.ceil(Math.log(key + 1));
    }

    private double bucketRatioFeature(Double key) {
        long bucket = Math.round(Math.log((key + 1) * 1000));
        if (bucket > 1000)
            bucket = 1000;
        return (double) bucket;
    }


    public void setOriginAdView(Object key) {
        if (key == null) {
            this.adView = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adView = Double.valueOf(formateKey);
        }
    }

    public void setOriginAdClick(Object key) {
        if (key == null) {
            this.adClick = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adClick = Double.valueOf(formateKey);
        }
    }

    public void setOriginAdConversion(Object key) {
        if (key == null) {
            this.adConversion = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adConversion = Double.valueOf(formateKey);
        }
    }

    // redis中保存原始值  server段统一处理
    public void setOriginCtr(Object key) {
        if (key == null) {
            this.ctr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ctr = Double.valueOf(formateKey);
        }
    }

    public void setOriginCvr(Object key) {
        if (key == null) {
            this.cvr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.cvr = Double.valueOf(formateKey);
        }
    }




    public void setAdView(Object key) {
        if (key == null) {
            this.adView = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adView = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setAdClick(Object key) {
        if (key == null) {
            this.adClick = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adClick = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setAdConversion(Object key) {
        if (key == null) {
            this.adConversion = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.adConversion = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setCtr(Object key) {
        if (key == null) {
            this.ctr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ctr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setCvr(Object key) {
        if (key == null) {
            this.cvr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.cvr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }


}
